//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 Red
#property indicator_width1 2

extern string TimeFrame = "Current time frame";
extern int Smooth       = 10;
extern int SmoothMethod = MODE_LWMA;

double Buffer1[];
double Buffer2[];

//
//
//
//
//

string indicatorFileName;
bool   returnBars;
bool   calculateValue;
int    timeFrame;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//

int init()
{
    IndicatorDigits(Digits+1);
    IndicatorBuffers(2);
    SetIndexBuffer(0, Buffer1);
    SetIndexBuffer(1, Buffer2);
    
      //
      //
      //
      //
      //
         
      timeFrame         = stringToTimeFrame(TimeFrame);
      indicatorFileName = WindowExpertName();
      returnBars        = TimeFrame=="returnBars";       if (returnBars)     return(0);
      calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);

      //
      //
      //
      //   
      //
      
      IndicatorShortName(timeFrameToString(timeFrame)+"  EVIndicator ("+Smooth+")");
    return(0);
}
int deinit()
{
    return(0);
}

//
//
//
//
//


int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { Buffer1[0] = MathMin(limit+1,Bars-1); return(0); }

   //
   //
   //
   //
   //
   
   if (calculateValue || timeFrame == Period())
   {
     for(int i=limit; i>=0; i--)
     {
        double dividend = Close[i]-Close[i+1]+Point;
        double divisor  = MathMax(High[i],Close[i+1])-MathMin(Low[i],Close[i+1])+Point;
           if (divisor!=0)
                 Buffer2[i] = dividend/divisor*Volume[i];
           else  Buffer2[i] = 0;
     }         
     for(i=limit; i>=0; i--) Buffer1[i] = iMAOnArray(Buffer2,0,Smooth,0,SmoothMethod,i);
   return(0);
   }

   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for(i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         Buffer1[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Smooth,SmoothMethod,0,y);
   }
return(0);      
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}